Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# ChannelSwitch Class Reference

`#include <channels.h>`

Inheritance diagram for ChannelSwitch:

List of all members.

## Detailed Description

Route input to different and/or multiple channels based on channel ID.

Definition at line 80 of file channels.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
virtual int | GetAutoSignalPropagation () const
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| ChannelSwitch (BufferedTransformation &destination)
| ChannelSwitch (BufferedTransformation &destination, const std::string &outChannel)
void | IsolatedInitialize (const NameValuePairs &parameters=g_nullNameValuePairs)
unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
unsigned int | ChannelPutModifiable2 (const std::string &channel, byte *begin, unsigned int length, int messageEnd, bool blocking)
bool | ChannelFlush (const std::string &channel, bool completeFlush, int propagation=-1, bool blocking=true)
bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
byte * | ChannelCreatePutSpace (const std::string &channel, unsigned int &size)
void | AddDefaultRoute (BufferedTransformation &destination)
void | RemoveDefaultRoute (BufferedTransformation &destination)
void | AddDefaultRoute (BufferedTransformation &destination, const std::string &outChannel)
void | RemoveDefaultRoute (BufferedTransformation &destination, const std::string &outChannel)
void | AddRoute (const std::string &inChannel, BufferedTransformation &destination, const std::string &outChannel)
void | RemoveRoute (const std::string &inChannel, BufferedTransformation &destination, const std::string &outChannel)
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
byte * | CreatePutSpace (unsigned int &size)
| request space which can be written into by the caller, and then used as input to Put()
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
unsigned int | PutModifiable2 (byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
bool | ChannelPutModifiable (const std::string &channel, byte *inString, unsigned int length)
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
## Static Protected Member Functions
int | DecrementPropagation (int propagation)

## Member Function Documentation

bool Multichannel< Sink >::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[inline, virtual, inherited]`

| Implements CustomFlushPropagation< Sink >. Definition at line 136 of file simple.h.

bool Multichannel< Sink >::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 138 of file simple.h.

byte* Multichannel< Sink >::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 140 of file simple.h.

unsigned int Multichannel< Sink >::Put2 | ( | const byte * | begin,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

| Implements BufferedTransformation. Definition at line 142 of file simple.h.

unsigned int Multichannel< Sink >::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 144 of file simple.h.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transferred signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 788 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 247 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 934 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- channels.h
- channels.cpp